; Ray casted shadows
; by Maciej Guba.
; http://macgub.co.pl


ROUND2 equ 10
;ray_shd:
;--- Procedure render triangle with ray casted shadow ---
;--- effect. Calc intersection with all triangles in ----
;--- everypixel. Its not real time process, especially --
;--- when many triangles are computed. ------------------
; initial block of instructions (sort, deltas and two --
; loops) - see file 3glasstex_.inc

ray_shd_l:
; in:
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;	    as dword integers
;    xmm4 - ----
;    mm7  - current triangle index
;    eax  - x1
;    ebx  - x2
;    ecx  - y
;    edx  - -----
;    edi  - screen buffer
;    esi  - z buffer / stencil buffer filled with dd floats
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi tx1, ty1, z1 coords as dwords float
;    xmm5 - lo -> hi tx2, ty2, z2 coords as dwords float

; transform if needed into:

;    xmm3 - lo -> hi z1, z2 coords as dwords floats


   push  ebp
   mov	 ebp,esp
   sub	 esp,230
   sub	 ebp,80
   and	 ebp,0xfffffff0


    movhlps  xmm3,xmm5
    shufps   xmm3,xmm3,11110010b


 .n1  equ [ebp-16]
 .n2  equ [ebp-32]
 .r1  equ [ebp-48]
 .lx1 equ [ebp-52]
 .lx2 equ [ebp-56]
 .z2  equ [ebp-60]
 .z1  equ [ebp-64]
 .screen    equ [ebp-68]
 .zbuff     equ [ebp-72]
 .x_max     equ [ebp-74]
 .x_min     equ [ebp-76]
 .y_max     equ [ebp-78]
 .y_min     equ [ebp-80]
 .dn	    equ [ebp-96]
 .dz	    equ [ebp-100]
 .y	    equ [ebp-104]
 .cur_tri   equ [ebp-108]
 .Rlen	    equ [ebp-112]
 .tri_cnt   equ dword[ebp-116]
; .lab	     equ dword[ebp-120]


 .cnv	    equ [ebp-32] ;128]

 .nray	    equ [ebp]
 .final_col equ [ebp+16]
 .zer_h     equ [ebp+32]
 .msk_255f  equ [ebp+48]
 .f1	    equ dword[ebp+64]
 .lae	    equ dword[ebp+68]
 .pplc	    equ dword[ebp+72]
 .intersect equ dword[ebp+76]
 .prptr     equ dword[ebp+80]


	mov	 .y,ecx
	movaps	  xmm4,xmm2
	packssdw  xmm2,xmm2
	movq	 .y_min,xmm2
	cmp	 cx,.y_min
	jl	 .end_rp_line
	cmp	 cx,.y_max
	jge	 .end_rp_line	       ;
	cmp	 eax,ebx
	je	 .end_rp_line
	jl	 @f
	xchg	 eax,ebx
	movaps	 xmm7,xmm0
	movaps	 xmm0,xmm1
	movaps	 xmm1,xmm7
	shufps	 xmm3,xmm3,11100001b
    @@:
	movd	 .cur_tri,mm7
	cmp	 ax,.x_max
	jge	 .end_rp_line
	cmp	 bx,.x_min
	jle	 .end_rp_line


	pcmpeqd  xmm7,xmm7
	psrldq	 xmm7,4
	movaps	 .zer_h,xmm7
	psrld	 xmm7,24
	cvtdq2ps xmm7,xmm7
	movaps	 .msk_255f,xmm7
	mov	 .f1,1.0
	mov	 .lae,lights_aligned_end	 ; label
	mov	 .pplc,point_light_coords	; label
	mov	 .intersect,intersect_tri	 ; label
	push	 [points_rotated_ptr]
	pop	 .prptr
	push	 [triangles_count_var]
	pop	 .tri_cnt
     ;	 mov	  .nx_lab_l,.nx_light		  ; label

	andps	 xmm0,.zer_h
	andps	 xmm1,.zer_h
	movaps	 .n1,xmm0
	movaps	 .n2,xmm1
	mov	 .lx1,eax
	mov	 .lx2,ebx
	movlps	 .z1,xmm3
	sub	 ebx,eax
	cvtsi2ss xmm7,ebx
	rcpss	 xmm7,xmm7
	shufps	 xmm7,xmm7,0
	subps	 xmm1,xmm0
	mulps	 xmm1,xmm7
	movaps	 .dn,xmm1
	shufps	 xmm3,xmm3,11111001b
	subss	 xmm3,.z1
	mulss	 xmm3,xmm7
	movss	 .dz,xmm3

	subps	 xmm6,xmm5
	mulps	 xmm6,xmm7

	mov	 ebx,.lx1
	cmp	 bx,.x_min     ; clipping on function4
	jge	 @f
	movzx	 eax,word .x_min
	sub	 eax,ebx
	cvtsi2ss xmm7,eax
	shufps	 xmm7,xmm7,0
	mulss	 xmm3,xmm7
	mulps	 xmm1,xmm7
	mulps	 xmm6,xmm7
	addss	 xmm3,.z1
	addps	 xmm1,.n1
	addps	 xmm6,xmm5
	movsx	 eax,word .x_min
	movss	 .z1,xmm3
	movaps	 .n1,xmm1
	mov	 dword .lx1,eax
      @@:
	movzx	 eax,word .x_max
	cmp	 .lx2,eax
	jl	 @f
	mov	 .lx2,eax
      @@:
	movzx	 eax,word[xres_var]
	mul	 dword .y
	add	 eax,.lx1
	mov	 .zbuff,esi
	mov	 .screen,edi
	shl	 eax,2
	add	 edi,eax
	add	 esi,eax
	mov	 ecx,.lx2
	sub	 ecx,.lx1

   .ddraw:
	xorps	 xmm0,xmm0
	movss	 xmm2,.z1
	movss	 xmm5,.z1
	movaps	 .final_col,xmm0
	addss	 xmm2,.f1
	subss	 xmm5,.f1
	cmpnltss xmm2,dword[esi]
	cmpnltss xmm5,dword[esi]
	xorps	 xmm2,xmm5
	movd	 eax,xmm2
	or	 eax,eax
	jz	 .skips

	movaps	 xmm7,.n1
	andps	 xmm7,.zer_h
	mulps	 xmm7,xmm7   ; normalize
	haddps	 xmm7,xmm7
	haddps	 xmm7,xmm7
	rsqrtps  xmm7,xmm7
	mulps	 xmm7,.n1
	movaps	 .cnv,xmm7
	mov	 ebx,.pplc
	mov	 edx,lights_aligned
	xor	 eax,eax

 .nx_light:
   pushad
   cvtsi2ss xmm0,.lx1
   cvtsi2ss xmm1,.y
   movss    xmm2,.z1
   movlhps  xmm0,xmm1
   shufps   xmm0,xmm2,11001000b
   subps    xmm0,[ebx]	 ; xmm0 - ray end, -> current vertex
   movaps   xmm3,[ebx]
   andps    xmm0,.zer_h
   movaps   xmm1,xmm0
   mulps    xmm0,xmm0
   haddps   xmm0,xmm0
   haddps   xmm0,xmm0
   sqrtps   xmm0,xmm0
   movss    .Rlen,xmm0
   rcpps    xmm0,xmm0
   mulps    xmm0,xmm1	 ; xmm0 - normalized ray vector
   andps    xmm0,.zer_h
   movaps   .nray,xmm0
   movaps   .r1,xmm3	 ; ray orgin
   mov	    edi,[triangles_ptr]
   xor	    ecx,ecx
 .nx_tri:		 ; next triangle
   push     edi
   push     ecx
   cmp	    ecx,.cur_tri  ; prevent self shadowing
   je	    @f
   mov	    eax,[edi]
   mov	    ebx,[edi+4]
   mov	    edx,[edi+8]
   imul     eax,12
   imul     ebx,12
   imul     edx,12
   add	    eax,.prptr ;[points_rotated_ptr]
   add	    ebx,.prptr
   add	    edx,.prptr
   movups   xmm2,[eax]
   movups   xmm3,[ebx]
   movups   xmm4,[edx]
;;   movaps   .p1t,xmm1     ; .p1t - tri 1st vertex
;;   movaps   .p2t,xmm2
;;   movaps   .p3t,xmm3


;intersect_tri: procs header
; in:
;     xmm0 - ray direction  ; should be normalized
;     xmm1 - ray orgin
;     xmm2 - tri vert1
;     xmm3 - tri vert2
;     xmm4 - tri vert3
;     if  eax = 1 - intersction with edge
;	 xmm6 - edge lenght
;     if  eax = 0 - intersect with ray (classic)
; out:
;     eax  = 1 - intersection occured
;     xmm0 - float lo -> hi = t, v, u, ...

   movss     xmm6,.Rlen
   movaps    xmm0,.nray
   movaps    xmm1,.r1
;   movaps    xmm2,.p1t
;   movaps    xmm3,.p2t
;   movaps    xmm4,.p3t
   subss     xmm6,.f1
   mov	     eax,1
   call      .intersect
   cmp	     eax,1
   je	     .inter
;   comiss  xmm0,.Rlen
;   jl	    .inter
  @@:
   pop	   ecx
   pop	   edi
   add	   edi,12
   inc	   ecx
   cmp	   ecx,.tri_cnt ;  [triangles_count_var]
   jnz	   .nx_tri
   popad

	movaps	 xmm5,.nray   ; [edx]
	andps	 xmm5,.zer_h
	mulps	 xmm5,.cnv    ; last dword should be zeroed
	haddps	 xmm5,xmm5
	haddps	 xmm5,xmm5
	movaps	 xmm7,xmm5
	mulps	 xmm7,xmm7
    ;	mulps	 xmm7,xmm7
	mulps	 xmm5,[edx+16]
	mulps	 xmm7,xmm7
	mulps	 xmm7,[edx+48]
	addps	 xmm5,xmm7
	minps	 xmm5,.msk_255f
	maxps	 xmm5,.final_col
	movaps	 .final_col,xmm5
      ;  inc	  eax
	jmp	 .nx_loop
   .inter:
	add	 esp,8
	popad

      .nx_loop:
	add	 edx,64
	add	 ebx,16
	cmp	 edx,.lae     ; lights_aligned_end    ; global
	jnz	 .nx_light
     ;	 mov	   eax,1
     ;	 cvtsi2ss  xmm1,eax

     ;	 rcpss	   xmm1,xmm1
     ;	 shufps    xmm1,xmm1,0
     ;	 mulps	   xmm1,.final_col
	movaps	  xmm1,.final_col
	cvtps2dq  xmm1,xmm1
	packssdw  xmm1,xmm1
	packuswb  xmm1,xmm1
	movd	  [edi],xmm1
  .skips:
	movaps	  xmm0,.n1
	movss	  xmm2,.z1
	add	  edi,4
	add	  esi,4
	inc	  dword .lx1
	addps	  xmm0,.dn
	addss	  xmm2,.dz
	movaps	  .n1,xmm0
	movss	  .z1,xmm2
	dec	  ecx
	jnz	  .ddraw
  .end_rp_line:
	add	  esp,230
	pop	  ebp

ret
